<?php
/*
declare(strict_types=1);

namespace mirzaev\parser_from_rossko;

use GuzzleHttp\Client as client,
	GuzzleHttp\Psr7\Request as request;

use DOMDocument as dom,
	DOMXPath as xpath;

ini_set('error_reporting', E_ALL);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

define('VIEWS', realpath('..' . DIRECTORY_SEPARATOR . 'views'));
define('STORAGE', realpath('..' . DIRECTORY_SEPARATOR . 'storage'));
define('INDEX', __DIR__);

// Автозагрузка
require __DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php';

// Инициализация клиента Guzzle
$client = new client(['cookies' => true]);

function auth(int $attempts = 5)
{
	global $client;

	if (--$attempts <= 0) return false;

	$request = new request('GET', 'https://krsk.rossko.ru/');

	return $client->sendAsync($request)
		->then(function ($response) {
			$dom = new dom;
			@$dom->loadHTML((string) $response->getBody());

			$xpath = new xpath($dom);

			// Кнопка "ВХОД" ('ul[class="header-top__menu-inner"] > li:nth-child(3)')
			$entries = $xpath->query('/html/body/div[1]/header/div[2]/div/div/nav/ul/li[5]/div/a/span');

			if (!empty($entries[0])) {
				// Аутентифицирован

				echo 'Аутентифицирован: ' . $entries[0]->textContent . "\n";

				return false;
			} else {
				// Не аутентиффицирован

				// Кнопка "ВХОД" ('ul[class="header-top__menu-inner"] > li:nth-child(3)')
				$entries = $xpath->query('/html/body/div[1]/header/div[2]/div[1]/div/nav/ul/li[3]/div/a/span');

				return $entries[0]->textContent === 'Вход';
			}
		})
		->then(function ($guest) use ($attempts, $client) {
			if ($guest) {
				// Не аутентифицирован

				echo "Не аутентифицирован\n";

				// Инициализация данных аккаунта [mail => '', password => '']
				$account = require(__DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'settings' . DIRECTORY_SEPARATOR . 'rossko.php');

				// Инициализация запроса для аутентификации
				$request = new request(
					'POST',
					'https://krsk.rossko.ru/utils/',
					[
						'Content-Type' => 'application/x-www-form-urlencoded; charset=UTF-8'
					],
					'auth%5Bemail%5D=' . urlencode($account['mail']) . '&auth%5Bpassword%5D=' . urlencode($account['password']) . '&action=auth&type=header'
				);

				$promise = $client->sendAsync($request)->then(function ($response) use ($attempts) {
					auth($attempts);
				});

				$promise->wait();
			} else {
				// Аутентифицирован (подразумевается) !!! могут быть ошибки

				return true;
			}
		});
}

// Аутентификация (проверяет или аутентифицирует)
auth()->wait();

echo (123); */
